<?php

namespace App\Http\Controllers\Admin;

/** Ajax Request */

use App\Exports\MemberExport;
use App\Http\Requests\Admin\MemberRequest;
use App\Models\User;
use App\Services\Interfaces\MemberRepositoryInterface;
use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use Illuminate\Http\RedirectResponse;
use App\Http\Controllers\Controller;
use Maatwebsite\Excel\Facades\Excel;

class MemberController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/members';
    /** View folder */
    private $viewDirectory= 'admin.members.';
    //
    private MemberRepositoryInterface $memberRepository;

    public function __construct(MemberRepositoryInterface $memberRepository)
    {
        $this->memberRepository = $memberRepository;
    }

    /**
     * Display a listing of the members.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('members.head');
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the members.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) //:View
    {
        $request->merge(['all_info'=> true]);
        if (isset($request->export)) {
            $members= $this->memberRepository->get($request);
            return Excel::download(new MemberExport($members, 'members'), 'Members.xlsx');
        }

        $request->merge(['paginate'=> true]);
        $members= $this->memberRepository->get($request);

        return view($this->viewDirectory.'grid',compact('members'));
    }

    public function fetchMembers(Request $request)
    {
        $members= $this->memberRepository->get($request);
        return $members;
    }

    /**
     * Show the form for creating a new User.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('members.store');
        $head= __('members.new');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created User in storage.
     * @param MemberRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(MemberRequest $request) :JsonResponse
    {
        $member= $this->memberRepository->save($request, null);

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('members.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified User.
     *
     * @param  User  $member
     * @return View
     */
    public function edit(User $member) :View
    {
        // dd($member->id);
        $action= route('members.update', $member->id);
        $head= __('members.edit');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified User in storage.
     * @param MemberRequest $request
     * @param User $member
     * @return RedirectResponse|Redirector
     */
    public function update(MemberRequest $request, User $member) :JsonResponse
    {
        $member= $this->memberRepository->save($request, $member);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('members.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified User from storage.
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $return= $this->memberRepository->destroy($request, $id);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Remove several members by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $return= $this->memberRepository->destroyAll($request);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Restore the specified User from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $return= $this->memberRepository->restore($request, $id);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Restore several members by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $return= $this->memberRepository->restoreAll($request);
        return response()->json($return[0], $return[1] ?? 200);
    }
}
